/*
 * PrintForm.java
 *
 * Created on 2007. majus 25., 0:52
 */

package Successio;

import java.util.LinkedList;
import javax.swing.DefaultListModel;

/**
 * Kiirato
 * @author  Andrew King
 */
public class PrintForm extends javax.swing.JFrame {
    
    Sch scheduler;
    Heir[] heirs;
    
    private DefaultListModel HeirList = new DefaultListModel();
    
    /** Creates new form PrintForm */
    public PrintForm(Heir[] heirs, Sch scheduler) {
        initComponents();
        this.scheduler=scheduler;
        this.heirs=heirs;
        //Beallitja a megvaltas gombot
        //A 0. orokos a feleseg!
        if(heirs[0].getInherit().equals("A vagyont az \u00F6zvegy haszon\u00E9lvezete terheli")||
                heirs[0].getInherit().equals("Az gi vagyont az \u00F6zvegy haszon\u00E9lvezete terheli")){
            Ademption.setEnabled(true);
        }
        else{
            Ademption.setEnabled(false);
        }
        for (int i = 0; i < heirs.length; i++)
        {
            String spaces = "-->";
            String props = "";
            for (int j = 2; j < heirs[i].getID().length()-2; j++)
                spaces = "  ".concat(spaces);
            for (Property prop : heirs[i].getProperties())
            {
                if(props.equals(""))
                    props = props.concat("Adom\u00E1ny: "+prop.getName()+" - "+String.valueOf(prop.getPrice()));
                else
                    props = props.concat(", "+prop.getName()+" - "+String.valueOf(prop.getPrice()));
            }
            this.HeirList.addElement(spaces+heirs[i].getName()+": "+heirs[i].getAssets()+"  "+heirs[i].getInherit()+"  "+props);
        }
        this.WriteList.setModel(this.HeirList);
        this.setVisible(true);
    }
    
    public PrintForm(String s){
        initComponents();
        Ademption.setEnabled(false);
        HeirList.addElement(s);
        this.WriteList.setModel(this.HeirList);
        this.setVisible(true);
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        jScrollPane1 = new javax.swing.JScrollPane();
        WriteList = new javax.swing.JList();
        Exit = new javax.swing.JButton();
        Ademption = new javax.swing.JButton();
        Restart = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        setTitle("\u00d6r\u00f6kl\u00e9s");
        WriteList.setModel(new javax.swing.AbstractListModel() {
            String[] strings = { "Item 1", "Item 2", "Item 3", "Item 4", "Item 5" };
            public int getSize() { return strings.length; }
            public Object getElementAt(int i) { return strings[i]; }
        });
        WriteList.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                WriteListMouseClicked(evt);
            }
        });

        jScrollPane1.setViewportView(WriteList);

        Exit.setText("Kil\u00e9p\u00e9s");
        Exit.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                ExitActionPerformed(evt);
            }
        });

        Ademption.setText("\u00d6r\u00f6kr\u00e9sz megv\u00e1lt\u00e1sa");
        Ademption.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                AdemptionActionPerformed(evt);
            }
        });

        Restart.setText("\u00dajraind\u00edt\u00e1s");
        Restart.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                RestartActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 447, Short.MAX_VALUE)
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(Ademption)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 118, Short.MAX_VALUE)
                        .addComponent(Restart)
                        .addGap(48, 48, 48)
                        .addComponent(Exit)))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 313, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 15, Short.MAX_VALUE)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(Ademption, javax.swing.GroupLayout.PREFERRED_SIZE, 25, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(Exit)
                    .addComponent(Restart))
                .addContainerGap())
        );
        java.awt.Dimension screenSize = java.awt.Toolkit.getDefaultToolkit().getScreenSize();
        setBounds((screenSize.width-475)/2, (screenSize.height-409)/2, 475, 409);
    }// </editor-fold>//GEN-END:initComponents

private void WriteListMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_WriteListMouseClicked
    // TODO add your handling code here:
    String [] keys={"rkls"};
    scheduler.makeContextMenu (keys, evt);
}//GEN-LAST:event_WriteListMouseClicked

    private void RestartActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_RestartActionPerformed
    Main.main(new String[0]);
    this.dispose();
    }//GEN-LAST:event_RestartActionPerformed

    private void AdemptionActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_AdemptionActionPerformed
    if(heirs[0].getInherit().equals("A vagyont az \u00F6zvegy haszon\u00E9lvezete terheli")){
        scheduler.ademption();
    }
    else{
        scheduler.ademption2();
    }
    this.dispose();
    }//GEN-LAST:event_AdemptionActionPerformed

    private void ExitActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_ExitActionPerformed
    System.exit(0);
    }//GEN-LAST:event_ExitActionPerformed
    
    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new LegatorForm();
            }
        });
    }
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton Ademption;
    private javax.swing.JButton Exit;
    private javax.swing.JButton Restart;
    private javax.swing.JList WriteList;
    private javax.swing.JScrollPane jScrollPane1;
    // End of variables declaration//GEN-END:variables
    
}
