/*
 * Legator.java
 *
 * Created on 2007. majus 23., 13:46
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package Successio;

import java.util.Vector;

/**
 * Orokhagyo osztaly, a Szemely osztalybol szarmaztatva
 * @author Tar Peter
 */
public class Legator extends Person {
    
    private double wealth;
    private Heir wife,mother,father,mmother,mfather,fmother,ffather;    //az orokhagyo felesege szulei es nagyszulei
    private boolean noWife;
    private Vector<LineageProperty> lineageProperties;  //a felmenoktol kapott vagyonok vektora
    
    
    /** Creates a new instance of Legator */
    public Legator(String name){
        super(name, "00");
        wealth=0;
        noWife=false;
        dead=true;
        setWife(new Heir("", "0"));
        setMother(new Heir("", "y"));
        setFather(new Heir("", "x"));
        setMmother(new Heir("", "yy"));
        setMfather(new Heir("", "yx"));
        setFmother(new Heir("", "xy"));
        setFfather(new Heir("", "xx"));
        lineageProperties=new Vector<LineageProperty>(0);
    }
    
    //Get, Set fuggvenyek
    public void setWealth(double wealth) {
        this.wealth = wealth;
    }    
    
    public double getWealth() {
        return wealth;
    }

    public void setWife(Heir wife) {
        this.wife = wife;
    }
    
    public Heir getWife() {
        return wife;
    }    
    public void setMother(Heir mother) {
        this.mother = mother;
    }
    
    public Heir getMother() {
        return mother;
    }
    public void setFather(Heir father) {
        this.father = father;
    }
    
    public Heir getFather() {
        return father;
    }
    public void setMfather(Heir mfather) {
        this.mfather = mfather;
    }
    
    public Heir getMfather() {
        return mfather;
    }
    public void setMmother(Heir mmother) {
        this.mmother = mmother;
    }
    
    public Heir getMmother() {
        return mmother;
    }
    public void setFmother(Heir fmother) {
        this.fmother = fmother;
    }
    
    public Heir getFmother() {
        return fmother;
    }
    public void setFfather(Heir ffather) {
        this.ffather = ffather;
    }
    
    public Heir getFfather() {
        return ffather;
    }
    
     public Vector<LineageProperty> getLineageProperties(){
        return this.lineageProperties;
    }
    public void setLineageProperties(Vector<LineageProperty> prop) {
        lineageProperties=prop;
    }
    
    public Heir[] getChildren(){
        return this.children.toArray(new Heir[0]);
    }

    public boolean isNoWife() {
        return noWife;
    }

    public void setNoWife(boolean noWife) {
        this.noWife = noWife;
    }
    
    public boolean canInherit(){
        return false;
    }
    
}
