/*
 * Model.java
 *
 * Created on 2007. majus 23., 16:39
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package Successio;

import java.util.TreeMap;

/**
 * Az adatmodel 
 * @author Tar Peter
 */
public class Model {
    
    private Legator legator; //Egy kulon adattag az orokhagyoe
    private TreeMap<String,Heir> heirs; //Az orokosok egy Map-be vannak tarolva, kulcsa az ID
    
    /** Creates a new instance of Model */
    public Model() {
        legator=new Legator("");
        heirs=new TreeMap<String,Heir>();
    }

    //Get, Set, Add fuggvenyek
    public void setLegator(Legator legator) {
        this.legator = legator;
    }

    public Legator getLegator() {
        return legator;
    }

    public void addHeir(Heir somebody){
        heirs.put(somebody.getID(), somebody);
    }
    
    public Heir getHeir(String id){
        return heirs.get(id);
    }
    
    public Heir[] getHeirs(){
        return this.heirs.values().toArray(new Heir[0]);
    }
   
}
